/***************************************************************************
 *   Copyright (C) 2004 by Raphael Langerhorst                             *
 *   raphael-langerhorst@gmx.at                                            *
 *                                                                         *
 *   Permission is hereby granted, free of charge, to any person obtaining *
 *   a copy of this software and associated documentation files (the       *
 *   "Software"), to deal in the Software without restriction, including   *
 *   without limitation the rights to use, copy, modify, merge, publish,   *
 *   distribute, sublicense, and/or sell copies of the Software, and to    *
 *   permit persons to whom the Software is furnished to do so, subject to *
 *   the following conditions:                                             *
 *                                                                         *
 *   The above copyright notice and this permission notice shall be        *
 *   included in all copies or substantial portions of the Software.       *
 *                                                                         *
 *   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,       *
 *   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF    *
 *   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.*
 *   IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR     *
 *   OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, *
 *   ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR *
 *   OTHER DEALINGS IN THE SOFTWARE.                                       *
 ***************************************************************************/

#include "GActiveElementInfluence.h"

namespace GBE {

GActiveElementInfluence::GActiveElementInfluence(const GCS::GElementID& source, const GCS::GEnergy& energy, const GCS::GVector3& position, const GCS::GVector3& rotation, double radius, const GCS::GElementID& parent, double sense_radius, double sense_radius_detail)
: GPositionalInfluence(source, energy, position, rotation, radius, parent),
  SenseRadius(sense_radius),
  SenseRadiusDetail(sense_radius_detail)
{
}


GActiveElementInfluence::~GActiveElementInfluence()
{
}

double GActiveElementInfluence::senseRadius() const
{
  return this->SenseRadius;
}

double GActiveElementInfluence::senseRadiusDetail() const
{
  return this->SenseRadiusDetail;
}

};
