/***************************************************************************
 *   Copyright (C) 2004 by Raphael Langerhorst                             *
 *   raphael-langerhorst@gmx.at                                            *
 *                                                                         *
 *   Permission is hereby granted, free of charge, to any person obtaining *
 *   a copy of this software and associated documentation files (the       *
 *   "Software"), to deal in the Software without restriction, including   *
 *   without limitation the rights to use, copy, modify, merge, publish,   *
 *   distribute, sublicense, and/or sell copies of the Software, and to    *
 *   permit persons to whom the Software is furnished to do so, subject to *
 *   the following conditions:                                             *
 *                                                                         *
 *   The above copyright notice and this permission notice shall be        *
 *   included in all copies or substantial portions of the Software.       *
 *                                                                         *
 *   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,       *
 *   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF    *
 *   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.*
 *   IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR     *
 *   OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, *
 *   ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR *
 *   OTHER DEALINGS IN THE SOFTWARE.                                       *
 ***************************************************************************/
 
#include "GPositionalInfluence.h"

using namespace GCS;

namespace GBE {


GPositionalInfluence::GPositionalInfluence(const GElementID& source, const GEnergy& energy,
                                           const GVector3& position,
                                           const GVector3& rotation,
                                           double radius,
                                           const GElementID& parent)
: GElementInfluence(source, energy),
  Position(position),
  Rotation(rotation),
  Radius(radius),
  Parent(parent)
{
}


GPositionalInfluence::~GPositionalInfluence()
{
}

const GVector3& GPositionalInfluence::position() const
{
  return Position;
}

const GVector3& GPositionalInfluence::rotation() const
{
  return Rotation;
}

const double GPositionalInfluence::radius() const
{
  return Radius;
}

const GElementID& GPositionalInfluence::parent() const
{
  return Parent;
}

};
