/***************************************************************************
 *   Copyright (C) 2004 by Raphael Langerhorst                             *
 *   raphael-langerhorst@gmx.at                                            *
 *                                                                         *
 *   Permission is hereby granted, free of charge, to any person obtaining *
 *   a copy of this software and associated documentation files (the       *
 *   "Software"), to deal in the Software without restriction, including   *
 *   without limitation the rights to use, copy, modify, merge, publish,   *
 *   distribute, sublicense, and/or sell copies of the Software, and to    *
 *   permit persons to whom the Software is furnished to do so, subject to *
 *   the following conditions:                                             *
 *                                                                         *
 *   The above copyright notice and this permission notice shall be        *
 *   included in all copies or substantial portions of the Software.       *
 *                                                                         *
 *   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,       *
 *   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF    *
 *   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.*
 *   IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR     *
 *   OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, *
 *   ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR *
 *   OTHER DEALINGS IN THE SOFTWARE.                                       *
 ***************************************************************************/

#ifndef CREATEUNIVERSEBUTTON_H
#define CREATEUNIVERSEBUTTON_H

#include <qpushbutton.h>
#include <qspinbox.h>
#include <qstring.h>

/**
  \class CreateUniverseButton CreateUniverseButton.h
  \brief Initialises universe with random seed of given SpinBox

  @author Raphael Langerhorst
*/
class CreateUniverseButton : public QPushButton
{
  Q_OBJECT
  
    QSpinBox* RandomSeed;
  
  public:
    CreateUniverseButton(QSpinBox* spin_box_random_seed, QString text = "Create Universe", QWidget *parent = 0, const char *name = 0);

    ~CreateUniverseButton();
    
  public slots:
    QWidget* createUniverse();

};

#endif
