/***************************************************************************
 *   Copyright (C) 2004 by Raphael Langerhorst                             *
 *   raphael-langerhorst@gmx.at                                            *
 *                                                                         *
 *   Permission is hereby granted, free of charge, to any person obtaining *
 *   a copy of this software and associated documentation files (the       *
 *   "Software"), to deal in the Software without restriction, including   *
 *   without limitation the rights to use, copy, modify, merge, publish,   *
 *   distribute, sublicense, and/or sell copies of the Software, and to    *
 *   permit persons to whom the Software is furnished to do so, subject to *
 *   the following conditions:                                             *
 *                                                                         *
 *   The above copyright notice and this permission notice shall be        *
 *   included in all copies or substantial portions of the Software.       *
 *                                                                         *
 *   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,       *
 *   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF    *
 *   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.*
 *   IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR     *
 *   OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, *
 *   ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR *
 *   OTHER DEALINGS IN THE SOFTWARE.                                       *
 ***************************************************************************/

// #include <kapplication.h>
// #include <kmainwindow.h>
// #include <kcmdlineargs.h>
 
#include <qapplication.h>
#include <qtimer.h>
#include <qvbox.h>
#include <qslider.h>
#include <qtoolbox.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qtextedit.h>

#include "CreateUniverseButton.h" 

#include <GElementID.h>



int main(int argc, char** argv)
{
  //NOTE the investigation interface has been removed, it's not the focus of the current demo!
  //     it's still available in the library though!
  //     You have to connect a lot of signals and slots to use it! Look at the 0.3.1 release for details.

//   KCmdLineArgs::init(argc,argv,"gdemo","evolution simulation","0.3",true);
//   KApplication a;
  QApplication a(argc,argv);
  
  //initialise available IDs
  GCS::GElementID::initFreeIDs(10,1000000);
    
  //KMainWindow mainFrame;
  
  QObject::connect(&a,SIGNAL(lastWindowClosed()),&a,SLOT(quit()));
  
  QVBox help(NULL);
  QTextEdit text(&help);
  text.setReadOnly(true);
  text.append("<h1><p align=\"center\">~ G System 0.4.1 development release ~</p></h1>");
  text.append("<p align=\"left\">How to navigate:</p>");
  text.append("Use space to move forward, use arrow keys to turn. Press enter for a full stop.");
  text.append("The demo represents a galaxy that is deterministically randomised. New solar systems are generated as you move into certain directions. If you move into a solar system, planets are created. Just go ahead, launch the demo and enjoy!");
  text.append("Future 0.4 releases will allow you to land on planets and continue exploration and even interaction. The next release series - 0.5 - will include network capability, which provides multi-user functionality. Further releases will focus on different aspects and finally create a huge virtual evolving universe.");
  text.append("The 0.4.1 release has mainly a much improved documentation compared to 0.4.0. In fact, the documentation will give you much more insight than just this demo, which is used as testing purposes only at the moment. You can always find the latest documentation on our website. You are encouraged to have a look at it.");
  text.append("You can find our website at http://www.g-system.at");
  text.append("You are welcome to take part in it! The whole project is still in an early stage of development.");
  
  QHBox start_box(&help);
  QSpinBox spin_box(&start_box);
  spin_box.setMinValue(0);
  spin_box.setMaxValue(30000);
  spin_box.setValue(7471);
  CreateUniverseButton start_button(&spin_box,"Create Universe",&start_box);
  QPushButton exit_button("Quit",&start_box);
  QObject::connect(&exit_button,SIGNAL(pressed()),qApp,SLOT(quit()));
  help.resize(600,400);
  help.show();
  
  //start the event loop
  return a.exec();
}
